<?php

namespace Itguild\EloquentTable;
use Exception;
use Itguild\Tables\ListJsonTable;

class ListEloquentTable
{
    private array $options;
    private string $model;
    private ListJsonTable $table;
    private EloquentDataProvider $dataProvider;
//    public int $currentPage;
//    public int $perPage;
//    public array $params;
//    public string $baseUrl;
//    public array $actions;


    /**
     * @throws Exception
     */
    public function __construct(array $options)
    {
        if (!isset ($options['model'])) {
            throw new Exception('Model option cannot be empty');
        }
        $this->model = $options['model'];
//        $this->currentPage = $options['currentPage'] ?? 1;
//        $this->perPage = $options['perPage'] ?? 5;
//        $this->params = $options['params'] ?? '';
//        $this->baseUrl = $options['base_url'] ?? '';
        $this->options['currentPage'] = $options['currentPage'] ?? 1;
        $this->options['perPage'] = $options['perPage'] ?? 5;
        $this->options['params'] = $options['params'] ?? [];
        $this->options['baseUrl'] = $options['baseUrl'] ?? '';
        $this->options['actions'] = $options['actions'] ?? [];
        $this->dataProvider = new EloquentDataProvider($this->model, $this->options);
        $this->table = new ListJsonTable($this->dataProvider->getJson());
    }

    /**
     * @throws Exception
     */
    public function create(): void
    {
        if (isset($this->options['actions']))
        {
            $this->getActions();
        }
        $this->table->create();
    }

    private function getActions(): void
    {
        foreach ($this->options['actions'] as $action)
        {
            $this->table->addAction($action);
        }
    }

    public function render(): void
    {
        $this->table->render();
    }
}